Неверный или поврежденный JAR-файл, созданный плагином Maven Shade

После добавления зависимости Maven jFree в мое существующее приложение я не могу выполнить созданный jar.

Я получаю только следующее сообщение об ошибке:

java -jar target/com.company.product-1.0.0-SNAPSHOT.jar 
Error: Invalid or corrupt jarfile target/com. company.product-1.0.0-SNAPSHOT.jar

Полныйpom.xml выглядит так:

<?xml version="1.0" encoding="UTF-8"?>

<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
<modelVersion>4.0.0</modelVersion
<groupId>com.mycompany</groupId>
<artifactId>com.mycompany.test</artifactId>
<name>${project.artifactId}</name>
<version>1.0.0-SNAPSHOT</version>

<properties>
    <java-version>1.7</java-version>
    <org.springframework-version>3.1.1.RELEASE</org.springframework-version>
    <org.springframework.data-version>1.0.3.RELEASE</org.springframework.data-version>
    <org.springframework.ws-version>2.0.4.RELEASE</org.springframework.ws-version>
    <org.springframework.ws.oxm-version>1.5.10</org.springframework.ws.oxm-version>
    <org.aspectj-version>1.6.12</org.aspectj-version>
    <org.slf4j-version>1.5.10</org.slf4j-version>
    <selenium-java-version>2.25.0</selenium-java-version>
    <browser-mob-version>2.0-beta-6</browser-mob-version>
</properties>

<dependencies>

    <!-- Hint A: If we delete this dependency it works -->
    <dependency>
        <groupId>org.jfree</groupId>
        <artifactId>jfreechart</artifactId>
        <version>1.0.14</version>
                    <exclusions>
            <exclusion>
                <artifactId>itext</artifactId>
                <groupId>com.lowagie</groupId>
            </exclusion>
        </exclusions>
    </dependency>

    <dependency>
        <groupId>com.itextpdf</groupId>
        <artifactId>itextpdf</artifactId>
        <version>5.3.2</version>
    </dependency>

    <dependency>
        <groupId>de.schlichtherle.io</groupId>
        <artifactId>truezip</artifactId>
        <version>6.6</version>
    </dependency>

    <dependency>
        <groupId>log4j</groupId>
        <artifactId>apache-log4j-extras</artifactId>
        <version>1.1</version>
    </dependency>

    <!-- Caching with ehcache -->
    <dependency>
        <groupId>net.sf.ehcache</groupId>
        <artifactId>ehcache</artifactId>
        <version>2.5.2</version>
        <type>pom</type>
    </dependency>

    <!-- Spring -->
    <dependency>
        <groupId>org.springframework</groupId>
        <artifactId>spring-context</artifactId>
        <version>${org.springframework-version}</version>
        <exclusions>
            <!-- Exclude Commons Logging in favor of SLF4j -->
            <exclusion>
                <groupId>commons-logging</groupId>
                <artifactId>commons-logging</artifactId>
            </exclusion>
        </exclusions>
    </dependency>
    <dependency>
        <groupId>org.springframework</groupId>
        <artifactId>spring-webmvc</artifactId>
        <version>${org.springframework-version}</version>
    </dependency>
    <dependency>
        <groupId>org.springframework</groupId>
        <artifactId>spring-core</artifactId>
        <version>${org.springframework-version}</version>
    </dependency>
    <dependency>
        <groupId>org.springframework</groupId>
        <artifactId>spring-beans</artifactId>
        <version>${org.springframework-version}</version>
    </dependency>
    <dependency>
        <groupId>org.springframework</groupId>
        <artifactId>spring-web</artifactId>
        <version>${org.springframework-version}</version>
    </dependency>
    <dependency>
        <groupId>org.springframework</groupId>
        <artifactId>spring-aop</artifactId>
        <version>${org.springframework-version}</version>
    </dependency>
    <dependency>
        <groupId>org.springframework</groupId>
        <artifactId>spring-context-support</artifactId>
        <version>${org.springframework-version}</version>
    </dependency>

    <dependency>
        <groupId>org.springframework</groupId>
        <artifactId>spring-tx</artifactId>
        <version>${org.springframework-version}</version>
    </dependency>

    <dependency>
        <groupId>org.springframework</groupId>
        <artifactId>spring-orm</artifactId>
        <version>${org.springframework-version}</version>
    </dependency>

    <dependency>
        <groupId>org.springframework.security</groupId>
        <artifactId>spring-security-core</artifactId>
        <version>3.0.3.RELEASE</version>
    </dependency>

    <dependency>
        <groupId>org.springframework.security</groupId>
        <artifactId>spring-security-web</artifactId>
        <version>3.0.3.RELEASE</version>
    </dependency>

    <dependency>
        <groupId>org.springframework.security</groupId>
        <artifactId>spring-security-config</artifactId>
        <version>3.0.3.RELEASE</version>
    </dependency>

    <dependency>
        <groupId>org.springframework</groupId>
        <artifactId>spring-test</artifactId>
        <version>${org.springframework-version}</version>
        <scope>test</scope>
    </dependency>
    <!-- Hibernate -->
    <dependency>
        <groupId>org.hibernate.java-persistence</groupId>
        <artifactId>jpa-api</artifactId>
        <version>2.0-cr-1</version>
    </dependency>

    <dependency>
        <groupId>org.hibernate</groupId>
        <artifactId>hibernate-entitymanager</artifactId>
        <version>3.5.1-Final</version>
    </dependency>

    <!-- Database Connectors (HSQL should be removed later) -->
    <dependency>
        <groupId>hsqldb</groupId>
        <artifactId>hsqldb</artifactId>
        <version>1.8.0.7</version>
    </dependency>

    <dependency>
        <groupId>mysql</groupId>
        <artifactId>mysql-connector-java</artifactId>
        <version>5.1.16</version>
    </dependency>

    <!-- AspectJ -->
    <dependency>
        <groupId>org.aspectj</groupId>
        <artifactId>aspectjrt</artifactId>
        <version>${org.aspectj-version}</version>
    </dependency>

    <!-- Logging -->
    <dependency>
        <groupId>org.slf4j</groupId>
        <artifactId>slf4j-api</artifactId>
        <version>${org.slf4j-version}</version>
    </dependency>

    <dependency>
        <groupId>log4j</groupId>
        <artifactId>log4j</artifactId>
        <version>1.2.16</version>
    </dependency>

    <!-- @Inject -->
    <dependency>
        <groupId>javax.inject</groupId>
        <artifactId>javax.inject</artifactId>
        <version>1</version>
    </dependency>

    <dependency>
        <groupId>javax.servlet</groupId>
        <artifactId>jstl</artifactId>
        <version>1.2</version>
    </dependency>

    <!-- Spring Data JPA dependencies -->
    <dependency>
        <groupId>org.springframework.data</groupId>
        <artifactId>spring-data-jpa</artifactId>
        <version>${org.springframework.data-version}</version>
    </dependency>
    <dependency>
        <groupId>javax.ws.rs</groupId>
        <artifactId>jsr311-api</artifactId>
        <version>1.1.1</version>
    </dependency>

    <dependency>
        <groupId>org.springframework.ws</groupId>
        <artifactId>spring-oxm</artifactId>
        <version>${org.springframework.ws.oxm-version}</version>
    </dependency>
    <dependency>
        <groupId>org.springframework.ws</groupId>
        <artifactId>spring-xml</artifactId>
        <version>${org.springframework.ws-version}</version>
    </dependency>
    <dependency>
        <groupId>org.springframework.ws</groupId>
        <artifactId>spring-ws-core</artifactId>
        <version>${org.springframework.ws-version}</version>
    </dependency>
    <dependency>
        <groupId>javax.xml</groupId>
        <artifactId>jaxb-impl</artifactId>
        <version>2.1</version>
    </dependency>
    <dependency>
        <groupId>javax.xml</groupId>
        <artifactId>jaxb-api</artifactId>
        <version>2.1</version>
    </dependency>

    <!-- Test -->
    <dependency>
        <groupId>junit</groupId>
        <artifactId>junit</artifactId>
        <version>4.7</version>
        <scope>test</scope>
    </dependency>

    <dependency>
        <groupId>org.mockito</groupId>
        <artifactId>mockito-all</artifactId>
        <version>1.9.0</version>
        <scope>test</scope>
    </dependency>

    <!-- Common Utils -->
    <dependency>
        <groupId>commons-lang</groupId>
        <artifactId>commons-lang</artifactId>
        <version>2.6</version>
    </dependency>

    <dependency>
        <groupId>commons-collections</groupId>
        <artifactId>commons-collections</artifactId>
        <version>3.2.1</version>
    </dependency>

    <dependency>
        <groupId>commons-cli</groupId>
        <artifactId>commons-cli</artifactId>
        <version>1.2</version>
    </dependency>       

    <!-- Selenium -->
    <dependency>
        <groupId>org.seleniumhq.selenium</groupId>
        <artifactId>selenium-java</artifactId>
        <version>${selenium-java-version}</version>
    </dependency>

    <dependency>
        <groupId>org.seleniumhq.selenium</groupId>
        <artifactId>selenium-firefox-driver</artifactId>
        <version>${selenium-java-version}</version>
    </dependency>

    <dependency>
        <groupId>org.seleniumhq.selenium</groupId>
        <artifactId>selenium-chrome-driver</artifactId>
        <version>${selenium-java-version}</version>
    </dependency>

    <!-- CSV Lib for Keyword Checker -->
    <dependency>
        <groupId>net.sf.opencsv</groupId>
        <artifactId>opencsv</artifactId>
        <version>2.0</version>
    </dependency>

    <!-- Google Places API -->
    <dependency>
        <groupId>com.google.api-client</groupId>
        <artifactId>google-api-client</artifactId>
        <version>1.10.3-beta</version>
        <exclusions>
            <exclusion>
                <artifactId>jackson-core-asl</artifactId>
                <groupId>org.codehaus.jackson</groupId>
            </exclusion>
        </exclusions>
    </dependency>
    <dependency>
        <groupId>com.google.api-client</groupId>
        <artifactId>google-api-client-appengine</artifactId>
        <version>1.10.3-beta</version>
    </dependency>

    <dependency>
        <groupId>org.codehaus.jackson</groupId>
        <artifactId>jackson-mapper-asl</artifactId>
        <version>1.9.9</version>
    </dependency>

    <!-- Google Geocode -->
    <dependency>
        <groupId>com.google.code.geocoder-java</groupId>
        <artifactId>geocoder-java</artifactId>
        <version>0.9</version>
    </dependency>

    <dependency>
        <groupId>com.googlecode.json-simple</groupId>
        <artifactId>json-simple</artifactId>
        <version>1.1</version>
    </dependency>

    <dependency>
        <groupId>com.googlecode.json-simple</groupId>
        <artifactId>json-simple</artifactId>
        <version>1.1</version>
    </dependency>

    <dependency>
        <groupId>net.sf.jgrapht</groupId>
        <artifactId>jgrapht</artifactId>
        <version>0.8.3</version>
    </dependency>

    <dependency>
        <groupId>jgraph</groupId>
        <artifactId>jgraph</artifactId>
        <version>5.13.0.0</version>
    </dependency>

    <!-- Apache Http Client -->
    <dependency>
        <groupId>org.apache.httpcomponents</groupId>
        <artifactId>httpclient</artifactId>
        <version>4.2.1</version>
    </dependency>

    <!-- Amazon web services client -->
    <dependency>
        <groupId>com.amazonaws</groupId>
        <artifactId>aws-java-sdk</artifactId>
        <version>1.2.15</version>
        <exclusions>
            <exclusion>
                <artifactId>jackson-core-asl</artifactId>
                <groupId>org.codehaus.jackson</groupId>
            </exclusion>
        </exclusions>
    </dependency>

    <!-- Docx4j - reading excel files  -->
    <dependency>
        <groupId>org.docx4j</groupId>
        <artifactId>docx4j</artifactId>
        <version>2.8.0</version>
    </dependency>

    <!-- Browser Mob Proxy -->

    <dependency>
        <groupId>biz.neustar</groupId>
        <artifactId>browsermob-proxy</artifactId>
        <version>${browser-mob-version}</version>
        <exclusions>
            <exclusion>
                <groupId>org.seleniumhq.selenium</groupId>
                <artifactId>selenium-api</artifactId>
            </exclusion>
            <exclusion>
                <artifactId>icu4j</artifactId>
                <groupId>com.ibm.icu</groupId>
            </exclusion>
            <exclusion>
                <artifactId>jackson-mapper-asl</artifactId>
                <groupId>org.codehaus.jackson</groupId>
            </exclusion>
            <exclusion>
                <artifactId>jackson-core-asl</artifactId>
                <groupId>org.codehaus.jackson</groupId>
            </exclusion>
            <exclusion>
                <groupId>org.slf4j</groupId>
                <artifactId>slf4j-jdk14</artifactId>
            </exclusion>
        </exclusions>
    </dependency>

    <!-- Hint B: If we copy this Apache POI dependencies to the top, it works -->
    <!-- Apache POI - for reading xlsx files -->
    <dependency>
        <groupId>org.apache.poi</groupId>
        <artifactId>poi</artifactId>
        <version>3.8</version>
    </dependency>

    <dependency>
        <groupId>org.apache.poi</groupId>
        <artifactId>poi-ooxml</artifactId>
        <version>3.8</version>
    </dependency>

    <dependency>
        <groupId>org.apache.xmlbeans</groupId>
        <artifactId>xmlbeans</artifactId>
        <version>2.5.0</version>
    </dependency>

    <dependency>
        <groupId>org.apache.poi</groupId>
        <artifactId>ooxml-schemas</artifactId>
        <version>1.1</version>
    </dependency>

</dependencies>

<build>
    <plugins>
        <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-compiler-plugin</artifactId>
            <configuration>
                <source>${java-version}</source>
                <target>${java-version}</target>
            </configuration>
        </plugin>

        <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-shade-plugin</artifactId>
            <version>1.7</version>
            <executions>
                <execution>
                    <phase>package</phase>
                    <goals>
                        <goal>shade</goal>
                    </goals>
                    <configuration>
                        <transformers>

                            <!-- must be SURE to do this with both spring.handlers and spring.schemas. 
                                otherwise you won't be able to use them in the spring config files. -->
                            <transformer implementation="org.apache.maven.plugins.shade.resource.AppendingTransformer">
                                <resource>META-INF/spring.handlers</resource>
                            </transformer>

                            <transformer implementation="org.apache.maven.plugins.shade.resource.AppendingTransformer">
                                <resource>META-INF/spring.schemas</resource>
                            </transformer>

                            <transformer implementation="org.apache.maven.plugins.shade.resource.ManifestResourceTransformer">
                                <mainClass>com.mycompany.test.Start</mainClass>
                            </transformer>
                        </transformers>

                        <filters>
                          <filter>
                            <artifact>bouncycastle:bcprov-jdk15</artifact>
                            <excludes>
                              <exclude>META-INF/BCKEY.DSA</exclude>
                              <exclude>META-INF/BCKEY.SF</exclude>
                              <exclude>META-INF/MANIFEST.MF</exclude>
                            </excludes>
                          </filter>
                        </filters>                          

                    </configuration>
                </execution>
            </executions>
        </plugin>

    </plugins>
</build>

Я не получаю никакой другой отладочной информации, если я выполню флягу.

Есть ли возможность проверить файл jar? Или что-то вродеjava -verbose...?

Действия по воспроизведению:

создать новую папкуСкопируйте Pom.xml сверху в папку.Сохраните маленький `public static void main (...). в src / main / java / com / mycompany / test / Start.javaвыполнятьmvn clean packageвыполнятьjava -jar target/com.mycompany.test-1.0.0-SNAPSHOT.jar

Приложение 1:

package com.mycompany.test;


public class Start
{
    public static void main(final String[] args) 
    {
        System.out.println("If you are able to get this printed with java -jar you made it. Thanks a lot! :)");
    }
}

Изменить 1:

Я начал удалять некоторые зависимости, чтобы определить проблему. Но у меня нет четкого понимания, что идет не так.

Теперь я выяснил (см. Подсказку B в pom.xml), что перемещение зависимостей Apache POI в начало решит проблему. Но все же я не знаю, как, почему и в чем проблема.

 maba26 окт. 2012 г., 09:38
Можете ли вы показать другие зависимости, которые у вас есть? Я хотел бы проверить ту же настройку, что и у вас, и посмотреть, есть ли у меня такая же проблема.
 d0x26 окт. 2012 г., 14:15
@maba Я добавил полный pom.xml
 d0x23 окт. 2012 г., 08:49
Это была просто опечатка в моем вопросе :(
 d0x26 окт. 2012 г., 13:09
Да, дай мне несколько минут.
 Guido Simone23 окт. 2012 г., 02:37
Интересно, что ошибка включает target / comcompany.product вместо target / com.company.product или это просто опечатка, вводящая вопрос?

Ответы на вопрос(2)

Решение Вопроса

pom.xml Вы показали нам, сapache-poi объявлено послеjfreechartтогда, как вы упомянули, я получаю поврежденный JAR. Замена порядка этих двух зависимостей действительно дает мне правильный JAR.

У меня есть некоторый предыдущий опыт работы сmaven-shade-plugin и когда я использовал его, у меня были проблемы с созданными банкамиMETA-INF каталог, поэтому я проверил это на наличие дефектов.

Я пытался скопировать (используя Total Commander)META-INF где-то в моей локальной файловой системе, и я заметил, что при копировании файлов вMETA-INF/licences/, Если бы я попытался скопировать их где-то по отдельности, и это сработало, но я не смог бы скопировать все это. Я пришел к выводу, что архив JAR / ZIP поврежден.

То, что я сделал, япоступил этот JAR в Total Commander (Ctrl+PgDown над файл JAR) и япереименованный thirdpartylicenses.txt вthirdpartylicenses.txt.wtf, Делая это, Total Commander предлагает сохранить это, и он перепаковывает JAR (у меня установлен плагин Total7zip Total Commander - если кто-то пробует это, и он не работает, попробуйте его с этим установленным).

После этого. Оно работает.

(Я также пытался упаковать все это без переименования, используя Cygwin'sunzip/zip команды, но это не сработало, новый архив все еще поврежден. Total Commander или плагин, который я упомянул, делает немного магии.)

Я думаю,maven-shade-plugin просто создает поврежденный или недействительный архив ZIP / JAR. Я не уверен, почему и, возможно, то, что я описал, не сработает ни для кого другого, но я подумал, что упомяну это, так что, возможно, я смогу помочь

Я не мог просто оставить это в покое, поэтому я вырыл глубже и думаю, что нашел ответ.

Плохо JAR содержит 65608 записей.хороший JAR содержит 65450 записей.

Угадай, каков верхний пределколичество записей длягладкий ZIP файл? Да уж. Статья Wiki говорит о формате ZIP64, который преодолевает это ограничение.

хороший JAR имеет меньше записей, потому что фактические зависимости меняются из-за позиции объявлений зависимостей в вашемpom.xml, (Как описано в этом ответе.)

Я посчитал записи, как это.

Collections.list(new JarFile("...").entries()).size();

Я использовалJava 7, которая, кажется, поддерживает новый формат ZIP64может быть, если кто-то попытается посчитать записи вПлохо JAR, использующий Java 5 или 6, получит ошибку (хотя я не уверен).

Я также пытался запустить JARвзорванный, Я распаковал весь JAR-файл в каталог и запустил все это так.

java -cp <dir/ com.mycompany.test.Start

Работал как шарм.

Нижняя линия. незлоупотреблять maven-shade-plugin.

У меня есть проект на работе, где я строю свой проект, как это.

Я копирую зависимости моего проекта, используяmaven-dependency-plugin, Оформить заказcopy-dependencies Цель, Это копирует ваши зависимости вtarget/dependency если я правильно помню.

С помощьюmaven-jar-plugin Я добавляю эти зависимости в мой последний JARMANIFEST.MF какClass-Path Записи, использующие эти параметры в конфигурации плагинов.

<classpathPrefix>dependency/</classpathPrefix>
<addClasspath>true</addClasspath>

Так что я буду иметьClass-Path записи какdependency/<artifactId>-<version>.jar, и т.д.

После этого я используюmaven-assembly-plugin создать дистрибутив ZIP, который содержит мой окончательный JAR и весьdependency/ папка.При развертывании приложения я могу запустить его какjava -jar final.jar.

В первую очередь я решил использовать это решение, потому что в моем проекте я использую несколько JAR-файлов Bouncy Castle, в которых JAR-файлы имеют некоторые экстравагантныеэто и то внутри ихMETA-INF каталог. Когда я использовалmaven-shade-plugin чтобы создать мой последний работающий JAR, весь ад вырвался, и я стал противнымэтот метод не может быть найден, и эта подпись не совсем верно ошибки.

Вы должны делать что-то подобное тоже. Этот бизнес Maven Shade слишкомсомнительный быть полезным (каламбур).

Вотсообщение в блоге обо всем процессе, который я пытался описать чуть выше (спасиборомовая баба), может быть, это поможет кому-то в будущем.

 maba31 окт. 2012 г., 10:19
Это действительно хорошая работа, которую вы сделали там! Я согласен, что это проблема. +1;
 d0x01 нояб. 2012 г., 02:55
Вау, спасибо за комментарий. Мне нужно посмотреть завтра.
 Scott Carey17 сент. 2013 г., 23:09
Обходной путь: в Java 7 он работает с 'java -cp final.jar MainClass', но не с 'java -jar final.jar', когда число записей превышает 2 ^ 16.
 Kenny Cason14 февр. 2015 г., 09:05
maven-сборка-плагин полностью! Это мой личный любимый упаковочный плагин! +1 ответ, понятия не имел об ограничениях zip в отношении количества записей!
 Nikola Yovchev29 дек. 2013 г., 12:17
Привет, @ Kohányi Róbert. У меня также был такой же вывод, как и у тебя, что сложные многомодульные проекты со странным META-INF или странной папкой ресурсов очень сложно создать с помощью плагина Shade. Вот почему я последовал вашему совету и использовал 3 простых плагина для создания баночки. Я написал в блоге об этом:ath3nd.wordpress.com/2013/12/25/... Может быть, вы можете обновить свой ответ с полной конфигурацией каждого плагина, чтобы он помог другим людям, которые сталкиваются с этим вопросом?

mvn dependency:tree с вашей настройкой, и это даст разницу, когда вы перемещаетеorg.apache.poi выше в объявлениях зависимостей.

Это взято изВведение в механизм зависимости относительно порядка зависимости:

Зависимость посредничество - определяет, какая версия зависимости будет использоваться при обнаружении нескольких версий артефакта. В настоящее время Maven 2.0 поддерживает только использование «ближайшего определения», что означает, что он будет использовать версию ближайшей зависимости к вашему проекту в дереве зависимостей. Вы всегда можете гарантировать версию, явно объявив ее в POM вашего проекта. Обратите внимание, что если две версии зависимостей находятся на одной и той же глубине в дереве зависимостей, до Maven 2.0.8 не было определено, какая из них победит,но начиная с Maven 2.0.9 учитывается порядок в объявлении: первое объявление выигрывает.

Кажется, существует конфликт в разрешении вашей зависимости, и это приводит к повреждению файла JAR (не знаю, почему он поврежден).

Во всяком случае, вот различия между двумя poms (слева это источник, справа это сorg.apache.poi выше):

(Может быть, это трудно увидеть на фотографиях, но если вы увеличите масштаб, вы увидите.)

Большая разница в том, что в нерабочем помorg.apache.httpcomponents:httpcore:jar:4.2.1 имеет зависимость отcommons-codec:commons-codec:jar:1.6и в рабочей помпе эта зависимость была переопределенаcommons-codec:commons-codec:jar:1.5.

Я думаю, что есть проблема с1.6 версияcommons-codec вместе сorg.apache.poi:poi:jar:3.8 который нуждается в1.5 версия.

редактировать

Послеэтот отличный ответ это объясняет, почему файл JAR поврежден (слишком много записей в банке). Я просто хочу добавить простое решение, которое по крайней мере работает для вашей конкретной проблемы.

Добавить тег<minimizeJar>true</minimizeJar> на вашmaven-shade-plugin конфигурации.

После этого вашjava -jar target/com.mycompany.test-1.0.0-SNAPSHOT.jar командная строка будет работать.

 d0x27 окт. 2012 г., 01:12
Спасибо за ваш пост. Как вы упомянули, было бы неплохо, если бы кто-то смог выяснить, почему баночка повреждена :(. Если я правильно помню, можно было также удалить все зависимости Spring, чтобы он запустился. Но в настоящее время я не на моем компьютере для тестирования Это :(

Ваш ответ на вопрос